(*
StartupAce About.pas Unit (About box implementation)
Copyright (C) 2006, 2007  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)

unit About;

interface

uses
  Windows, OleCtrls, SHDocVw, SpTBXControls, Classes, Controls, TBXDkPanels, 
  Forms;

type
  TAboutBox = class(TForm)
    OkBtn: TSpTBXButton;
    SpTBXPanel1: TSpTBXPanel;
    TitleLb: TSpTBXLabel;
    WebBrowser1: TWebBrowser;
    VersionLb: TSpTBXLabel;
    VersionNoLb: TSpTBXLabel;
    InternalVersionNoLb: TSpTBXLabel;
    InternalVersionLb: TSpTBXLabel;
    AuthorLb: TSpTBXLabel;
    PublishDateLb: TSpTBXLabel;
    LicenseLb: TSpTBXLabel;
    procedure FormCreate(Sender: TObject);
    procedure LicenseLbClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  AboutBox: TAboutBox;

implementation

uses
  Version, ShellAPI, SysUtils;

{$R *.dfm}

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  VersionNoLb.Caption := IntToStr(StartupAceVersion.Major) +
    '.' + IntToStr(StartupAceVersion.Minor);
  InternalVersionNoLb.Caption := IntToStr(StartupAceVersion.Internal);
  PublishDateLb.Caption := StartupAceVersion.PublishDate;
  WebBrowser1.Navigate('file:///' + ExtractFilePath(ParamStr(0)) + 'doc\acknowledgement.htm');
  LicenseLb.Constraints.MaxWidth := Width - Margins.Left - Margins.Right;
  LicenseLb.Height := Height - LicenseLb.Top;
end;

procedure TAboutBox.LicenseLbClick(Sender: TObject);
begin
  ShellExecuteW(handle, 'open', 'http://www.gnu.org/copyleft/lesser.html', '',
    '', SW_SHOWNORMAL);
end;

end.
