(*
StartupAce EditLongStringForm.pas Unit (long argument list editing form's implementation)
Copyright (C) 2006  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)
unit EditLongStringForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TntStdCtrls, TntForms;

type
  TEditLongStringsForm = class(TTntForm)
    Memo: TTntMemo;
    OKButton: TTntButton;
    CancelButton: TTntButton;
  private
    function GetText: WideString;
    procedure SetText(const Value: WideString);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function Execute: Boolean;
    property Text: WideString read GetText write SetText;
  end;

implementation

{$R *.dfm}

{ TForm1 }

function TEditLongStringsForm.Execute: Boolean;
begin
  Result := self.ShowModal = mrOK;
end;

function TEditLongStringsForm.GetText: WideString;
var
  I: Integer;
  s: WideString;
begin
  s := Memo.Text;
  I := Length(s);
  while I > 0 do
  begin
    if s[I] = #10 then
    begin
      Dec(I);
      Delete(s, I, 2);  // delete #13#10
      Insert(' ', s, I);  // insert space
    end;
    Dec(I);    
  end;
  Result := s;
end;

procedure TEditLongStringsForm.SetText(const Value: WideString);
begin
  Memo.Text := Value;
end;

end.
