(*
StartupAce LinkFiles.pas Unit
Copyright (C) 2006  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)

// This was indeed not written by me. Source:
// http://www.swissdelphicenter.ch/de/showcode.php?id=970

unit LinkFiles;

interface

uses
  Windows,
  ActiveX,
  ShlObj,
  ComObj,
  CommCtrl;

type
  TShellLinkInfoStruct = record
    LnkFilePath: array [0..MAX_PATH] of WideChar;
    LinkedFilePath: array [0..MAX_PATH] of WideChar;
    Parameters: array [0..MAX_PATH] of WideChar;
    WorkingDirectroyPath: array[0..MAX_PATH] of WideChar;
    Description: array[0..MAX_PATH] of WideChar;
    IconContainingFilePath: array[0..MAX_PATH] of WideChar;
    IconIndex: Integer;
    HotKey: Word;
    ShowCommand: Integer;
    FindData: TWin32FindDataW;
  end;
  PShellLinkInfoStruct = ^TShellLinkInfoStruct;

  procedure GetLinkInfo(lpShellLinkInfoStruct: PShellLinkInfoStruct);

implementation

procedure GetLinkInfo(lpShellLinkInfoStruct: PShellLinkInfoStruct);
var
  ShellLink: IShellLinkW;
  PersistFile: IPersistFile;
  AnObj: IUnknown;
begin
  // access to the two interfaces of the object
  AnObj       := CreateComObject(CLSID_ShellLink);
  ShellLink   := AnObj as IShellLinkW;
  PersistFile := AnObj as IPersistFile;

  // Opens the specified file and initializes an object from the file contents.
  PersistFile.Load(PWChar(WideString(lpShellLinkInfoStruct^.LnkFilePath)), 0);
  with ShellLink do
  begin
    // Retrieves the path and file name of a Shell link object.
    GetPath(lpShellLinkInfoStruct^.LinkedFilePath,
      SizeOf(lpShellLinkInfoStruct^.LnkFilePath),
      lpShellLinkInfoStruct^.FindData,
      SLGP_UNCPRIORITY);

    // Retrieves the description string for a Shell link object.
    GetDescription(lpShellLinkInfoStruct^.Description,
      SizeOf(lpShellLinkInfoStruct^.Description));

    // Retrieves the command-line arguments associated with a Shell link object.
    GetArguments(lpShellLinkInfoStruct^.Parameters,
      SizeOf(lpShellLinkInfoStruct^.Parameters));

    // Retrieves the name of the working directory for a Shell link object.
    GetWorkingDirectory(lpShellLinkInfoStruct^.WorkingDirectroyPath,
      SizeOf(lpShellLinkInfoStruct^.WorkingDirectroyPath));

    // Retrieves the location (path and index) of the icon for a Shell link object.
    GetIconLocation(lpShellLinkInfoStruct^.IconContainingFilePath,
      SizeOf(lpShellLinkInfoStruct^.IconContainingFilePath),
      lpShellLinkInfoStruct^.IconIndex);

    // Retrieves the hot key for a Shell link object.
    GetHotKey(lpShellLinkInfoStruct^.HotKey);

    // Retrieves the show (SW_) command for a Shell link object.
    GetShowCmd(lpShellLinkInfoStruct^.ShowCommand);
  end;
end;

end.
