(* StartupAce Main.pas Unit (main configuration form's implementation)
 * Copyright (C) 2006, 2007  Jakob Reschke
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *)

unit Main;

interface

uses
  StartupEntry, TBXOffice2003Theme, StartupAceSettings, 
  StartupEntryFilter, Dialogs, TntDialogs, Menus, TB2Item, TBX, SpTBXItem,
  TBXSwitcher, ExtCtrls, VirtualTrees, SpTBXControls, SpTBXEditors, TBXDkPanels,
  StdCtrls, Controls, Buttons, SpTBXDkPanels, TB2Dock, TB2Toolbar, Classes,
  TntForms, Graphics, Types, Messages, XPMan, TntMenus, Forms;

type
  TStartupAceMainFormState = (stCustom, stEditingEntry);

  TDelayConnection = record
    TreeNode: PVirtualNode;
    MemorizedDelay: Cardinal;
  end;

  TMainForm = class(TTntForm)
    TopDock: TSpTBXDock;
    SpTBXToolbar1: TSpTBXToolbar;
    SpTBXSubmenuItem1: TSpTBXSubmenuItem;
    SpTBXSubmenuItem2: TSpTBXSubmenuItem;
    ShowOnlyEditableItemsMI: TSpTBXItem;
    HintTimer: TTimer;
    ReloadMI: TSpTBXItem;
    SaveMI: TSpTBXItem;
    TBXSwitcher1: TTBXSwitcher;
    StatusBar: TSpTBXStatusBar;
    SpTBXRightAlignSpacerItem1: TSpTBXRightAlignSpacerItem;
    VersionNoLb: TSpTBXLabelItem;
    VSTPopupMenu: TSpTBXPopupMenu;
    EditEntryMI: TSpTBXItem;
    ResetEntryMI: TSpTBXItem;
    DeleteEntryMI: TSpTBXItem;
    SpTBXSeparatorItem1: TSpTBXSeparatorItem;
    ResetAllEntriesMI: TSpTBXItem;
    MsgLb: TSpTBXLabelItem;
    NewEntryMI: TSpTBXItem;
    TntOpenDialog1: TTntOpenDialog;
    SpTBXSeparatorItem2: TSpTBXSeparatorItem;
    VSTPMExecuteEntryMI: TSpTBXItem;
    SpTBXSeparatorItem3: TSpTBXSeparatorItem;
    TestStartMI: TSpTBXItem;
    SpTBXSeparatorItem4: TSpTBXSeparatorItem;
    StartPausedMI: TSpTBXItem;
    ClientPanel: TSpTBXPanel;
    VST: TVirtualStringTree;
    DelayShifterPanel: TSpTBXDockablePanel;
    SpTBXSubmenuItem3: TSpTBXSubmenuItem;
    DelayShifterMI: TSpTBXItem;
    DelayShifterShiftValueSEd: TSpTBXSpinEdit;
    DelayShifterShiftValueSEdFrontLb: TSpTBXLabel;
    DelayShifterShiftValueSEdBehindLb: TSpTBXLabel;
    DelayShifterHintLb: TSpTBXLabel;
    DelayShifterButtonsPanel: TSpTBXPanel;
    DelayShifterApplyBtn: TSpTBXButton;
    DelayShifterUndoBtn: TSpTBXButton;
    HelpMI: TSpTBXSubmenuItem;
    AboutMI: TSpTBXItem;
    GoToMI: TSpTBXItem;
    XPManifest1: TXPManifest;
    ToggleOffice2003StyleMI: TSpTBXItem;
    GoToPathMI: TSpTBXItem;
    SpTBXItem1: TSpTBXItem;
    HomePageMI: TSpTBXItem;
    StartMinimizedMI: TSpTBXItem;
    procedure FormCreate(Sender: TObject);
    procedure VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
    procedure FormShow(Sender: TObject);
    procedure VSTBeforeItemErase(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; ItemRect: TRect;
      var ItemColor: TColor; var EraseAction: TItemEraseAction);
    procedure VSTPaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType);
    procedure VSTKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure VSTBeforeCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure VSTClick(Sender: TObject);
    procedure VSTCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure VSTHeaderClick(Sender: TVTHeader; Column: TColumnIndex;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ShowOnlyEditableItemsMIClick(Sender: TObject);
    procedure SaveMIClick(Sender: TObject);
    procedure ReloadMIClick(Sender: TObject);
    procedure VSTPopupMenuPopup(Sender: TObject);
    procedure ResetEntryMIClick(Sender: TObject);
    procedure DeleteEntryMIClick(Sender: TObject);
    procedure VSTFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure ResetAllEntriesMIClick(Sender: TObject);
    procedure StartupEntryPanelCloseQuery(Sender: TObject;
      var CanClose: Boolean);
    procedure NewEntryMIClick(Sender: TObject);
    procedure VSTPMExecuteEntryMIClick(Sender: TObject);
    procedure TestStartMIClick(Sender: TObject);
    procedure StartPausedMIClick(Sender: TObject);
    procedure TntFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DelayShifterMIClick(Sender: TObject);
    procedure DelayShifterPanelResize(Sender: TObject);
    procedure DelayShifterPanelVisibleChanged(Sender: TObject);
    procedure DelayShifterApplyBtnClick(Sender: TObject);
    procedure DelayShifterPanelClose(Sender: TObject);
    procedure TntFormDestroy(Sender: TObject);
    procedure DelayShifterUndoBtnClick(Sender: TObject);
    procedure AboutMIClick(Sender: TObject);
    procedure VSTEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; var Allowed: Boolean);
    procedure VSTCreateEditor(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; out EditLink: IVTEditLink);
    procedure GoToMIClick(Sender: TObject);
    procedure DelayShifterShiftValueSEdExit(Sender: TObject);
    procedure ToggleOffice2003StyleMIClick(Sender: TObject);
    procedure GoToPathMIClick(Sender: TObject);
    procedure TntFormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpTBXItem1Click(Sender: TObject);
    procedure HomePageMIClick(Sender: TObject);
    procedure StartMinimizedMIClick(Sender: TObject);
  private
    FShowOnlyEditableEntries: Boolean;
    FOffice2003Style: Boolean;
    procedure SetShowOnlyEditableEntries(const Value: Boolean);
    procedure StartupEntryChanged(Sender: TStartupEntry);
    procedure DeleteSelectedAutostart;
    procedure SetOffice2003Style(const Value: Boolean);
  public
    const WM_STARTEDITING = WM_USER + 778;
    const COL_CAPTION = 0;
    const COL_PATH = 1;
    const COL_ARGS = 2;
    const COL_TYPE = 3;
    const COL_DELAY = 4;
    const COL_ALLUSERS = 5;
    const COL_ACTIVE = 6;
    const COL_WAITFOR = 7;
    const COL_ENTRYPLACE = 8;
  strict private
    procedure WMStartEditing(var Message: TMessage); message WM_STARTEDITING;
  strict private
    Admin: Boolean;
    LastSortedColumn: TColumnIndex;
    LastSortDirection: TSortDirection;
    HighlightVSTColumns: Cardinal;
    FilterVST: TStartupEntryFilter;
    DelayShifterUndoMemory: array of TDelayConnection;
    procedure RenameSelectedStartupEntry;
  protected
    function AddNode(Autostart: TStartupEntry; Parent: PVirtualNode): PVirtualNode; overload;
    function AddNode(Parent: PVirtualNode): PVirtualNode; overload;
//    procedure HintDelayElapsed(Sender: TObject);
    function GetSelectedNodeData: TStartupEntry;
    function GetAnyChanged: Boolean;
    procedure FilterChanged;
  public
    AllEditable: Boolean;
    procedure Save;
    procedure ReloadStartupEntries;
//    procedure LoadSettings;
    property SelectedStartupEntry: TStartupEntry read GetSelectedNodeData;
    { Public-Deklarationen }
  published
    property ShowOnlyEditableEntries: Boolean read FShowOnlyEditableEntries write SetShowOnlyEditableEntries;
    property AnyEntriesChanged: Boolean read GetAnyChanged;
    property Office2003Style: Boolean  read FOffice2003Style write SetOffice2003Style;
  end;

  TEntryEditLink = class (TInterfacedObject, IVTEditLink)
    private
      FEdit: TWinControl;
      FForm: TMainForm;
      FExtraControls: array of TWinControl;
      FExtraComponents: array of TComponent;
      FTree: TVirtualStringTree;
      FNode: PVirtualNode;
      FColumn: TColumnIndex;
    protected
      procedure EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure BrowseForPath(Sender: TObject);
      procedure ShowArgumentOptions(Sender: TObject);
      procedure ArgOptionsInsertPathClick(Sender: TObject);
      procedure ArgOptionsLongListClick(Sender: TObject);
      procedure HideControls;
    public
      destructor Destroy; override;
      function BeginEdit: Boolean; stdcall;
      function CancelEdit: Boolean; stdcall;
      function EndEdit: Boolean; stdcall;
      function GetBounds: TRect; stdcall;
      function PrepareEdit(Tree: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex): Boolean; stdcall;
      procedure SetBounds(R: TRect); stdcall;
      procedure ProcessMessage(var Message: TMessage); stdcall;
  end;

const
  C_Caption = 1;
  C_Path = 2;
  C_Parameters = 4;
  C_RunType = 8;
  C_Delay = 16;
  C_AllUsers = 32;
  C_Active = 64;
  C_Editable = 128;

var
  MainForm: TMainForm;

implementation

uses
  Registry, Statics, Policy, paths, Math, ShellAPI, ShlObj, 
  ActiveX, UnsavedChangesDlg, ComObj, About, Windows, SysUtils,
  EditLongStringForm, PathCtrls, RenameEntryFrm, Version, msxmldom, 
  MessageStrs, StUpEntrysLoader;

{$R *.dfm}

type
  TControlPos = record
    Parent: TWinControl;
    Width: Integer;
    TabIndex: Integer;
  end;
  PControlPos = ^TControlPos;

procedure TMainForm.FilterChanged;
var
  n: PVirtualNode;
  e: PStartupEntry;
begin
  n := VST.GetFirst;
  while n <> nil do
  begin
    e := VST.GetNodeData(n);
    VST.NodeHeight[n] := VST.DefaultNodeHeight;
    if FilterVST.Filter and C_RunType <> 0 then
      if e.RunType <> FilterVST.ComparasionEntry.RunType then
        VST.NodeHeight[n] := 0;
    if (VST.NodeHeight[n] > 0) and (FilterVST.Filter and C_Editable <> 0)  then
      if not (e.Editable or AllEditable) then
        VST.NodeHeight[n] := 0;              
    n := VST.GetNext(n);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  AllEditable := false;
  VST.NodeDataSize := sizeof(TStartupEntry);
  Admin := IsAdmin;
  HighlightVSTColumns := 0;
  FilterVST := TStartupEntryFilter.Create;
  FilterVST.OnChanged := FilterChanged;
  VersionNoLb.Caption := IntToStr(StartupAceVersion.Major) + '.'
    + IntToStr(StartupAceVersion.Minor);
//  TBXSwitcher1.Theme := 'Office2003';
//  LoadSettings;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  ShowOnlyEditableEntries := false;
  StartPausedMI.Checked := TStartupAceSettings.StartPaused;
  Office2003Style := TStartupAceSettings.Office2003Style;
  StartMinimizedMI.Checked := TStartupAceSettings.StartMinimized;
  ReloadStartupEntries;
end;

function TMainForm.GetAnyChanged: Boolean;
var
  node: PVirtualNode;
begin
  Result := false;
  node := VST.GetFirst;
  while not Result and (node <> nil) do
  begin
    Result := PStartupEntry(VST.GetNodeData(node))^.Changed;
    node := VST.GetNext(node);
  end;
end;

function TMainForm.GetSelectedNodeData: TStartupEntry;
begin
  if VST.FocusedNode <> nil then
    Result := PStartupEntry(VST.GetNodeData(VST.FocusedNode))^
  else
    Result := nil;
end;

procedure TMainForm.GoToMIClick(Sender: TObject);
var
  s: WideString;
begin
  s := MessageStrings.RegistryBrowsingNotImplemented;
  case SelectedStartupEntry.RunType of
    rtStartupAce: MessageBoxW(handle, PWideChar(s), nil, MB_ICONINFORMATION);
    rtRegistry: MessageBoxW(handle, PWideChar(s), nil, MB_ICONINFORMATION);
    rtLnk:
      if SelectedStartupEntry.AllUsers then
        ShellExecuteW(handle, 'open', 'explorer', PWChar('/select,"' +
          GetSpecialFolder(CSIDL_COMMON_STARTUP) + '\' + SelectedStartupEntry.Caption
          + '.lnk"'), nil, SW_SHOWNORMAL)
      else
        ShellExecuteW(handle, 'open', 'explorer', PWChar('/select,"' +
          GetSpecialFolder(CSIDL_STARTUP) + '\' + SelectedStartupEntry.Caption
          + '.lnk"'), nil, SW_SHOWNORMAL);
    rtNone: ;
  end;
end;

procedure TMainForm.ReloadStartupEntries;
begin
  StartupEntriesLoader.Load(VST, StartupEntryChanged, Cardinal(-1));
  VST.SetFocus;
  VST.FocusedNode := VST.GetFirst;
end;

procedure TMainForm.RenameSelectedStartupEntry;
var
  n: PVirtualNode;
  aborted: Boolean;
  P: TPoint;
  NodeDisplayRect: TRect;
  label RenameIt;
begin
  with TRenameEntryForm.Create(Self) do
  begin
    try        
      NodeDisplayRect := VST.GetDisplayRect(VST.FocusedNode, 0, false);
      P.X := NodeDisplayRect.Right;
      P.Y := NodeDisplayRect.Bottom;
      P := VST.ClientToScreen(P);
      Left := P.X;
      Top := P.Y;
      NewEntryCaption := SelectedStartupEntry.Caption;
      RenameIt:
      if Execute and (NewEntryCaption <> SelectedStartupEntry.Caption) then
      begin
        aborted := False;
        n := VST.GetFirst;
        while not aborted and (n <> nil) do
        begin
          if PStartupEntry(VST.GetNodeData(n)).Caption = NewEntryCaption then
          begin
            if MessageBoxW(handle, PWideChar(MessageStrings.NameInUse),
              PWideChar(MessageStrings.NameInUseTitle),
              MB_ICONWARNING or MB_YESNO) = ID_YES
            then
            begin
              goto RenameIt;
            end
            else
            begin
              aborted := True;
            end;          
          end;
          n := VST.GetNext(n);
        end;
        if not aborted then
        begin
          SelectedStartupEntry.Caption := NewEntryCaption;
        end;
      end;
    finally
      Free;
    end;   
  end;
end;

procedure TMainForm.ReloadMIClick(Sender: TObject);
begin
  if AnyEntriesChanged then
  begin
    if MessageBoxW(self.handle, PWideChar(MessageStrings.DiscardChanges),
      PWideChar(MessageStrings.Confirmation),
      MB_ICONQUESTION or MB_YESNO) = ID_YES then
    begin
      ReloadStartupEntries
    end
  end
  else
  begin
    ReloadStartupEntries;
  end;
end;

procedure TMainForm.Save;
var
  node: PVirtualNode;
  e: PStartupEntry;
  e2: TStartupEntry;
  reg: TRegistry;
  tempnode: PVirtualNode;
  s: WideString;
  OneStartupAceEntry: Boolean;
  ContinueProc: Boolean;

  function WriteStartupAceEntry(e: PStartupEntry): Boolean;
  var
    StrBuf: array of WideChar;
    Arr: array [0..0] of WideString;
  begin
    Result := False;
    OneStartupAceEntry := True;
    if e.AllUsers then
      reg.RootKey := HKEY_LOCAL_MACHINE
    else
      reg.RootKey := HKEY_CURRENT_USER;
    if reg.OpenKey(RegistryKeys.StartupAce + '\' + e.Caption, true) then
    begin
      reg.WriteString('Path', UTF8Encode(e.Path));
      reg.WriteString('Parameters', UTF8Encode(e.Arguments));
      reg.WriteInteger('Delay', e.Delay);
      reg.WriteString('Active', BoolToStr(e.Active));
      if e.WaitFor = '' then
      begin
        if reg.ValueExists('WaitFor') then
          reg.DeleteValue('WaitFor')
      end
      else
        reg.WriteString('WaitFor', UTF8Encode(e.WaitFor));
      reg.CloseKey;
      Result := True;
    end
    else
    begin
      Arr[0] := e.Caption;
      SetLength(StrBuf, MAXWORD);
      SetLength(StrBuf,
        FormatMessageW(
          FORMAT_MESSAGE_FROM_STRING or FORMAT_MESSAGE_ARGUMENT_ARRAY,
          PWideChar(MessageStrings.CannotAccessEntrysRegistryKey),
          0, 0,
          @StrBuf[0], Length(StrBuf), @Arr[0]));
      MessageBoxW(Application.Handle,
        PWideChar(StrBuf),
        nil,
        MB_OK or MB_ICONERROR);
      SetLength(StrBuf, 0);
    end;
  end;

  function WriteNormalRegistryEntry(e: PStartupEntry): Boolean;
  begin
    Result := False;
    if e.AllUsers then
      reg.RootKey := HKEY_LOCAL_MACHINE
    else
      reg.RootKey := HKEY_CURRENT_USER;
    if reg.OpenKey(RegistryKeys.Run, true) then
    begin
      s := '"' + e.Path + '"';
      if Length(Trim(e.Arguments)) > 0 then
        s := s + ' ' + e.Arguments;
      if not e.Active then
        s := 'REM ' + s;
      reg.WriteString(e.Caption, s);
      s := '';
      reg.CloseKey;
      Result := True;
    end
    else
    begin
      MessageBoxW(Application.Handle,
        PWideChar(MessageStrings.CannotAccessRunKey),
        nil,
        MB_OK or MB_ICONERROR);
    end;
  end;

  function WriteLinkFile(e: PStartupEntry): Boolean;
  var
    IObj: IUnknown;
    Link: IShellLinkW;
    IPFile: IPersistFile;
  begin
    Result := False;
    IObj := CreateComObject(CLSID_ShellLink);
    Link := IObj as IShellLinkW;
    IPFile := IObj as IPersistFile;
    with Link do
    begin
      if e.Active then
      begin
        SetPath(PWideChar(e.Path));
        SetArguments(PWideChar(e.Arguments));
      end
      else
      begin
        SetPath('REM');
        SetArguments(PWideChar('"' + e.Path + '" ' + e.Arguments));
      end;
    end;
    if e.AllUsers then
      IPFile.Save(PWideChar(GetSpecialFolder(CSIDL_COMMON_STARTUP) + '\' +
        e.Caption + '.lnk'), false)
    else
      IPFile.Save(PWideChar(GetSpecialFolder(CSIDL_STARTUP) + '\' +
        e.Caption + '.lnk'), false);
    Result := True;
  end;

  function DeleteOldStartupAceEntry(e: PStartupEntry): Boolean;
  begin
    Result := False;
    if e.OriginalAllUsers then
      reg.RootKey := HKEY_LOCAL_MACHINE
    else
      reg.RootKey := HKEY_CURRENT_USER;
    if reg.OpenKey(RegistryKeys.StartupAce, false) then
    begin
      reg.DeleteKey(e.OriginalCaption);
      reg.CloseKey;
      Result := True;
    end
    else
    begin
      MessageBoxW(Application.Handle,
        PWideChar(MessageStrings.CannotAccessStartupAceKey),
        nil,
        MB_OK or MB_ICONERROR);
    end;
  end;

  function DeleteOldRegistryEntry(e: PStartupEntry): Boolean;
  begin
    Result := False;
    if e.OriginalAllUsers then
      reg.RootKey := HKEY_LOCAL_MACHINE
    else
      reg.RootKey := HKEY_CURRENT_USER;
    if reg.OpenKey(RegistryKeys.Run, false) then
    begin
      reg.DeleteValue(e.OriginalCaption);
      reg.CloseKey;
      Result := True;
    end
    else
    begin
      MessageBoxW(Application.Handle,
        PWideChar(MessageStrings.CannotAccessRunKey),
        nil,
        MB_OK or MB_ICONERROR);
    end;
  end;

  function DeleteOldLnkFile(e: PStartupEntry): Boolean;
  begin
    Result := False;
    if e.OriginalAllUsers then
      DeleteFileW(PWideChar(
        GetSpecialFolder(CSIDL_COMMON_STARTUP) + '\' +
        e.OriginalCaption + '.lnk'))
    else
      DeleteFileW(PWideChar(
        GetSpecialFolder(CSIDL_STARTUP) + '\' +
        e.OriginalCaption + '.lnk'));
    Result := True;
  end;

  function QueryContinue: Boolean;
  begin
    Result := MessageBoxW(handle, PWideChar(MessageStrings.SaveErrorAbort),
                PWideChar(MessageStrings.Question),
                MB_YESNO or MB_ICONQUESTION) = ID_NO;
  end;

var
  StrBuf: array of WideChar;
  Arr: array [0..0] of WideString;

begin
  OneStartupAceEntry := False;
  ContinueProc := True;
  node := VST.GetFirst;
  {$REGION 'Make sure there are no interferencing duplicate names'}
  with TStringList.Create do
  begin
    try
      while node <> nil do
      begin
        e := VST.GetNodeData(node);
        if IndexOf(e.Caption) < 0 then
        begin
          AddObject(e.Caption, e^);
        end
        else
        begin
          e2 := Objects[IndexOf(e.Caption)] as TStartupEntry;
          if (e2.AllUsers = e.AllUsers) and (e2.RunType = e.RunType) then
          begin
            Arr[0] := e.Caption;
            SetLength(StrBuf, MAXWORD);
            SetLength(StrBuf,
              FormatMessageW(
                FORMAT_MESSAGE_FROM_STRING or FORMAT_MESSAGE_ARGUMENT_ARRAY,
                PWideChar(MessageStrings.NameUsedMultipleTimes),
                0, 0,
                @StrBuf[0],
                Length(StrBuf),
                @Arr[0]
                ));
            MessageBoxW(handle,PWideChar(StrBuf),
              PWideChar(MessageStrings.DuplicateName),
              MB_ICONWARNING);
            SetLength(StrBuf, 0);
            
            VST.FocusedNode := node;
            node := VST.GetFirst;
            while node <> nil do
            begin
              VST.Selected[node] := node = VST.FocusedNode;
              node := VST.GetNext(node);
            end;
            VST.SetFocus;
            Exit;
          end;
        end;
        node := VST.GetNext(node);
      end;
    finally
      Free;
    end;
  end;
  {$ENDREGION}
  reg := TRegistry.Create;
  try
    {$REGION 'Delete old entries'}
    node := VST.GetFirst;
    while ContinueProc and (node <> nil) do
    begin
      e := VST.GetNodeData(node);
      if e.Save(True, False) = False then
        ContinueProc := QueryContinue;
//      if e.Deleted
//        or (e.Caption <> e.OriginalCaption)  
//        or (e.OriginalAllUsers <> e.AllUsers)
//        or (e.RunType <> e.OriginalRunType) then
//      begin
//        case e.OriginalRunType of
//          rtStartupAce:
//            if not DeleteOldStartupAceEntry(e) then
//              ContinueProc := QueryContinue;
//          rtRegistry:                       
//            if not DeleteOldRegistryEntry(e) then
//              ContinueProc := QueryContinue;
//          rtLnk:
//            if not DeleteOldLnkFile(e) then
//              ContinueProc := QueryContinue;
//        end;  
//      end;
      // if entry was deleted, remove from tree, else continue w/ next node
      if e.Deleted then
      begin
        tempnode := node;
        node := VST.GetNext(node);
        VST.DeleteNode(tempnode);
      end
      else
        node := VST.GetNext(node);
    end;
    
    {$ENDREGION}
    {$REGION 'Write new and changed entries'}
    node := VST.GetFirst;
    while ContinueProc and (node <> nil) do
    begin
      e := VST.GetNodeData(node);
      if e.Save(False, True) = False then
        ContinueProc := QueryContinue;
      VST.InvalidateNode(node);
//      if e.Changed and not e.Deleted then
//      begin
//        case e.RunType of
//          rtStartupAce: if not WriteStartupAceEntry(e) then
//            ContinueProc := QueryContinue;
//          rtRegistry: if not WriteNormalRegistryEntry(e) then
//            ContinueProc := QueryContinue;
//          rtLnk: if not WriteLinkFile(e) then
//            ContinueProc := QueryContinue;
//        end;
//        if ContinueProc then
//          e.SetCurrentAsOriginalValues;
//        VST.InvalidateNode(node);
//        reg.CloseKey;
//      end;
      node := VST.GetNext(node);
    end;
    if ContinueProc and reg.OpenKey(RegistryKeys.StartupAce, true) then
    begin
      reg.WriteInteger('Version', StartupAceVersion.Major shl 24
        or StartupAceVersion.Minor shl 16
        or StartupAceVersion.Internal);
      if OneStartupAceEntry then
      begin
        StartupAceStartupEntries.RegisterStartup;
      end;
    end;
    {$ENDREGION}
    if VST.FocusedNode = nil then
      VST.FocusedNode := VST.GetFirst;
  finally
    reg.CloseKey;
    reg.Free;
  end;
end;

procedure TMainForm.SaveMIClick(Sender: TObject);
begin
  if AnyEntriesChanged then
  begin
    if MessageBoxW(handle, PWideChar(MessageStrings.ReallySave),
      PWideChar(MessageStrings.Confirmation),
      MB_ICONQUESTION or MB_YESNO) = ID_YES then
    begin
      Save;
    end;
  end;
end;

procedure TMainForm.SetOffice2003Style(const Value: Boolean);
begin
  FOffice2003Style := Value;    
  TStartupAceSettings.Office2003Style := Value;
  if Value then
    TBXSwitcher1.Theme := 'Office2003'
  else
    TBXSwitcher1.Theme := 'Default';
  ToggleOffice2003StyleMI.Checked := Value;
end;

procedure TMainForm.SetShowOnlyEditableEntries(const Value: Boolean);
begin
  FShowOnlyEditableEntries := Value;
  ShowOnlyEditableItemsMI.Checked := FShowOnlyEditableEntries;
  case Value of
    True: FilterVST.Filter := FilterVST.Filter or DWORD(-Integer(Value)) and C_Editable;
    False: FilterVST.Filter := FilterVST.Filter and (DWORD(-1) - C_Editable);
  end;
end;

procedure TMainForm.DelayShifterApplyBtnClick(Sender: TObject);
var
  n: PVirtualNode;
  I: Integer;
  e: PStartupEntry;
begin
  if Length(DelayShifterUndoMemory) = 0 then
  begin
    I := 0;
    {$REGION 'Count editable StartupAce entries to I'}
      n := VST.GetFirst;
      while n <> nil do
      begin
        e := VST.GetNodeData(n);
        if (e.Editable or AllEditable) and (e.RunType = rtStartupAce) then
        begin
          Inc(I);
        end;
        n := VST.GetNext(n);
      end;
    {$ENDREGION}
    SetLength(DelayShifterUndoMemory, I);
    I := 0;
    n := VST.GetFirst;
    while n <> nil do
    begin
      e := VST.GetNodeData(n);
      if (e.Editable or AllEditable) and (e.RunType = rtStartupAce) then
      begin
        DelayShifterUndoMemory[I].TreeNode := n;
        DelayShifterUndoMemory[I].MemorizedDelay := e.Delay;
        Inc(I);
      end;
      n := VST.GetNext(n);
    end;
  end;
  for I := 0 to Length(DelayShifterUndoMemory) - 1 do
  begin
    e := VST.GetNodeData(DelayShifterUndoMemory[I].TreeNode);
    if Integer(e.Delay) + DelayShifterShiftValueSEd.ValueAsInteger > 0 then
      e.Delay := e.Delay + Cardinal(DelayShifterShiftValueSEd.ValueAsInteger)
    else
      e.Delay := 0;
  end;
  DelayShifterUndoBtn.Enabled := true;
end;

procedure TMainForm.DelayShifterMIClick(Sender: TObject);
begin
  DelayShifterPanel.Show;
end;

procedure TMainForm.DelayShifterPanelClose(Sender: TObject);
begin
  SetLength(DelayShifterUndoMemory, 0);
  DelayShifterUndoBtn.Enabled := false;
  HighlightVSTColumns := 0;
  FilterVST.Filter :=
    DWORD(-Integer(ShowOnlyEditableEntries))
    and C_Editable;
end;

procedure TMainForm.DelayShifterPanelResize(Sender: TObject);
begin
  DelayShifterHintLb.Constraints.MaxWidth := DelayShifterPanel.Width - DelayShifterButtonsPanel.Width;
  DelayShifterHintLb.Width := DelayShifterPanel.Width - DelayShifterButtonsPanel.Width;
end;

procedure TMainForm.DelayShifterPanelVisibleChanged(Sender: TObject);
begin
  if DelayShifterPanel.Visible then
  begin
    DelayShifterPanel.Width := DelayShifterPanel.Width - DelayShifterButtonsPanel.Width;
    HighlightVSTColumns := C_Delay;    
    FilterVST.ComparasionEntry.RunType := rtStartupAce;
    FilterVST.ComparasionEntry.AllUsers := false;
    FilterVST.Filter := C_RunType or C_Editable;
    VST.Invalidate;
  end;
end;

procedure TMainForm.DelayShifterShiftValueSEdExit(Sender: TObject);
var
  s: array [0..5] of WChar;
begin
  if GetWindowTextW(DelayShifterShiftValueSEd.Handle, s, 6) > 0 then
  begin
    try
      DelayShifterShiftValueSEd.ValueAsInteger := StrToInt(WideString(s));
    except
      MessageBoxW(handle, 'This is not a number! You have to enter an integral number between -86400 and 86400!',
        'Errorneous Input', MB_OK or MB_ICONWARNING);
      DelayShifterShiftValueSEd.SetFocus;
    end;
  end;
end;

procedure TMainForm.DelayShifterUndoBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to Length(DelayShifterUndoMemory) - 1 do
  begin
    PStartupEntry(VST.GetNodeData(
      DelayShifterUndoMemory[I].TreeNode
      )).Delay := DelayShifterUndoMemory[I].MemorizedDelay;
  end;
  DelayShifterUndoBtn.Enabled := false;
end;

procedure TMainForm.DeleteEntryMIClick(Sender: TObject);
begin
  DeleteSelectedAutostart;
end;

procedure TMainForm.DeleteSelectedAutostart;
begin
  if PStartupEntry(VST.GetNodeData(VST.FocusedNode))^.Editable or AllEditable then
    PStartupEntry(VST.GetNodeData(VST.FocusedNode))^.Deleted := true;
end;

procedure TMainForm.ShowOnlyEditableItemsMIClick(Sender: TObject);
begin
  ShowOnlyEditableEntries := not ShowOnlyEditableEntries;
end;

procedure TMainForm.SpTBXItem1Click(Sender: TObject);
begin
  Save;
end;

procedure TMainForm.ResetAllEntriesMIClick(Sender: TObject);
var
  node: PVirtualNode;
  data: PStartupEntry;
begin
  node := VST.GetFirst;
  while node <> nil do
  begin
    data := VST.GetNodeData(node);
    data^.Reset;
    node := VST.GetNext(node);
  end;
end;

procedure TMainForm.NewEntryMIClick(Sender: TObject);
var
  N: PVirtualNode;
  data: PStartupEntry;
begin
  N := VST.AddChild(nil);
  data := VST.GetNodeData(N);
  data^ := TStartupEntry.Create(N);
  data^.Path := '';
  data^.Caption := 'New Autostart';
  data^.Arguments := '';
  data^.RunType := rtNone;
  data^.Active := true;
  data^.Delay := 0;
  data^.AllUsers := false;
  data.SetCurrentAsOriginalValues;
  data.RunType := rtStartupAce;
  VST.Selected[VST.FocusedNode] := false;
  VST.FocusedNode := N;
  VST.Selected[N] := true;
end;

procedure TMainForm.GoToPathMIClick(Sender: TObject);
begin
  ShellExecuteW(handle, 'open', 'explorer',
    PWideChar('/select,' + SelectedStartupEntry.Path), nil, SW_SHOWNORMAL);
end;

procedure TMainForm.HomePageMIClick(Sender: TObject);
begin
  ShellExecuteW(handle, 'open', 'http://jayk.de.gg/?startupace', nil, nil,
    SW_SHOWNORMAL);
end;

procedure TMainForm.TestStartMIClick(Sender: TObject);
begin
  ShellExecute(handle, 'open', PChar(ParamStr(0)), 'start', nil, SW_SHOWNORMAL);
end;

procedure TMainForm.TntFormClose(Sender: TObject; var Action: TCloseAction);
begin
  VST.CancelEditNode;
end;

procedure TMainForm.TntFormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  n: PVirtualNode;
  e: PStartupEntry;
begin
  n := VST.GetFirst;
  while n <> nil do
  begin
    e := VST.GetNodeData(n);
    if e.Changed then
    begin
      case TUnsavedChangesDialog.Show of
        TUnsavedChangesDialog.ResultCancel: CanClose := false;
        TUnsavedChangesDialog.ResultSave: Save;
        TUnsavedChangesDialog.ResultDiscard: CanClose := true;
      end;
      n := nil;
    end
    else
    begin
      n := VST.GetNext(n);
    end;
  end;
end;

procedure TMainForm.TntFormDestroy(Sender: TObject);
begin
  FilterVST.Free;
end;

procedure TMainForm.ToggleOffice2003StyleMIClick(Sender: TObject);
begin
  self.Office2003Style := not self.Office2003Style;
end;

procedure TMainForm.ResetEntryMIClick(Sender: TObject);
begin
  SelectedStartupEntry.Reset;
end;

procedure TMainForm.VSTBeforeCellPaint(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  CellRect: TRect);
var
  e: PStartupEntry;
begin
  e := Sender.GetNodeData(Node);
  if not e^.Deleted then
  begin
    case Column of
      COL_PATH:
      begin
        if (Length(e.Path) >= 2) and (e.Path[2] = ':') and not TPath.Exists(TPath.Expand(e.Path)) then
        begin
          TargetCanvas.Brush.Color := $8888FF;
          TargetCanvas.FillRect(CellRect);
        end;
      end;
      COL_TYPE:
      begin
        if e.RunType = rtStartupAce then
        begin
          TargetCanvas.Brush.Color := $DDFFDD;
        end
        else
        begin
          TargetCanvas.Brush.Color := $EEEEFF;
        end;
        TargetCanvas.FillRect(CellRect);
      end;
    end;
  end;
  // highlighting
  if HighlightVSTColumns and (1 shl Column) <> 0 then
  begin
    TargetCanvas.Brush.Color := $AAFFFF;
    TargetCanvas.FillRect(CellRect);
  end;
end;

procedure TMainForm.VSTBeforeItemErase(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; ItemRect: TRect;
  var ItemColor: TColor; var EraseAction: TItemEraseAction);
var
  data: PStartupEntry;
begin
  data := Sender.GetNodeData(Node);
    if data^.Deleted then
    begin
      ItemColor := clRed;
      EraseAction := eaColor;
    end
    else if not data^.Active then
    begin
      ItemColor := $E5E5E5;
      EraseAction := eaColor;
    end
    else
    begin
      ItemColor := $FFFFFF;
      EraseAction := eaColor;
    end;
end;

procedure TMainForm.VSTClick(Sender: TObject);
var
  n: PVirtualNode;
  c: Integer;
  P: TPoint;
begin
  P := VST.ScreenToClient(Mouse.CursorPos);
  c := VST.Header.Columns.ColumnFromPosition(P, false);
  if (c >= 0) and (c <> COL_ENTRYPLACE) then
  begin
    n := VST.GetNodeAt(P.X, P.Y);
    if n <> nil then
      SendMessage(handle, WM_STARTEDITING, Integer(n), c);
  end;
end;

procedure TMainForm.VSTCompareNodes(Sender: TBaseVirtualTree; Node1,
  Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  data1, data2: PStartupEntry;

  function CmprStrs(const str1: WideString; const str2: WideString): ShortInt;
  begin
    Result := CompareStringW(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
      PWideChar(str1), Length(str1),
      PWideChar(str2), Length(str2)) - 2;
  end;
  
begin
  data1 := Sender.GetNodeData(Node1);
  data2 := Sender.GetNodeData(Node2);
  case Column of
    COL_CAPTION: Result := CmprStrs(data1^.Caption, data2^.Caption);
    COL_PATH: result := CmprStrs(data1^.Path, data2^.Path);
    COL_ARGS: Result := CmprStrs(data1^.Arguments, data2^.Arguments);
    COL_TYPE: Result := Integer(data1^.RunType) -
                    Integer(data2^.RunType);
    COL_DELAY: Result := data1^.Delay - data2^.Delay;
    COL_ALLUSERS: Result := Integer(data1^.AllUsers) -
                  Integer(data2^.AllUsers);
    COL_ACTIVE: result := Integer(data1^.Active) -
                  Integer(data2^.Active);
  end;
end;

procedure TMainForm.VSTCreateEditor(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);
begin
  EditLink := TEntryEditLink.Create;
end;

procedure TMainForm.VSTEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; var Allowed: Boolean);
var
  e: PStartupEntry;
begin
  e := Sender.GetNodeData(Node);
  Allowed := (Column > -1)          // a column is selected
    and (e.Editable or AllEditable) // entry is editable or its forced
    and (Column <> COL_CAPTION)     // caption can't be changed in VST
    and ((Column <> COL_ALLUSERS) or AllEditable or (Admin)) // all users
      // column can only be edited as admin or when it is forced
    and ((Column <> COL_DELAY) or (e.RunType = rtStartupAce)  // delay column
      // can only be edited if entry is run by startup ace
      );
end;

procedure TMainForm.VSTFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  data: PStartupEntry;
begin
  data := Sender.GetNodeData(Node);
  data^.Free;
end;

procedure TMainForm.VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
var
  e: PStartupEntry;
begin
  e := PStartupEntry(Sender.GetNodeData(node));
  case Column of
    COL_CAPTION: CellText := e.Caption;
    COL_PATH: CellText := e.Path;
    COL_ARGS: CellText := e.Arguments;
    COL_TYPE:
      case e^.RunType of
        rtStartupAce: CellText := 'Startup Ace';
        rtRegistry: CellText := 'Registry';
        rtLnk: CellText := 'Startup folder';
      end;
    COL_DELAY: CellText := IntToStr(e^.Delay);
    COL_ALLUSERS: if e.AllUsers then
                  CellText := 'Yes'
                 else
                  CellText := 'No';
    COL_ACTIVE: if e.Active then
                  CellText := 'Yes'
                else
                  CellText := 'No';
    COL_WAITFOR: CellText := e.WaitFor;                 
    COL_ENTRYPLACE:
      case e.RunType of
        rtStartupAce:
        begin
          if e.AllUsers then
            CellText := 'HKEY_LOCAL_MACHINE\'
          else
            CellText := 'HKEY_CURRENT_USER\';
          CellText := CellText + RegistryKeys.StartupAce + '\' +
            e.Caption + '\';
        end;
        rtRegistry:
        begin
          if e.AllUsers then
            CellText := 'HKEY_LOCAL_MACHINE\'
          else
            CellText := 'HKEY_CURRENT_USER\';
          CellText := CellText + RegistryKeys.Run + '\' + e.Caption;
        end;
        rtLnk:
        begin
          if e.AllUsers then
            CellText := GetSpecialFolder(CSIDL_COMMON_STARTUP) + '\' + e.Caption + '.lnk'
          else
            CellText := GetSpecialFolder(CSIDL_STARTUP) + '\' + e.Caption + '.lnk';
        end;
      end;
  end;
end;

procedure TMainForm.VSTHeaderClick(Sender: TVTHeader; Column: TColumnIndex;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Column <> LastSortedColumn then
    LastSortDirection := sdAscending
  else
    if LastSortDirection = sdAscending then
      LastSortDirection := sdDescending
    else
      LastSortDirection := sdAscending;
  VST.SortTree(Column, LastSortDirection);
  LastSortedColumn := Column;
end;

procedure TMainForm.VSTKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_DELETE: DeleteSelectedAutostart;
    VK_F2:
      begin
        if AllEditable or SelectedStartupEntry.Editable then
          RenameSelectedStartupEntry;
      end;
    VK_F3:
      begin
        SendMessage(handle, WM_STARTEDITING,
          Integer(SelectedStartupEntry.TreeNode), COL_PATH); 
      end;
    VK_F4:
      begin
        SendMessage(handle, WM_STARTEDITING,
          Integer(VST.FocusedNode), COL_ARGS);
      end;
    VK_F5:
      begin
        SendMessage(handle, WM_STARTEDITING,
          Integer(VST.FocusedNode), COL_TYPE);
      end;
    VK_F6:
      begin
        SendMessage(handle, WM_STARTEDITING,
          Integer(VST.FocusedNode), COL_DELAY);
      end;
    VK_F7:
      begin
        if AllEditable or Admin then
          SelectedStartupEntry.AllUsers := not SelectedStartupEntry.AllUsers;
      end;
    VK_F8:
      begin
        if AllEditable or SelectedStartupEntry.Editable then
          SelectedStartupEntry.Active := not SelectedStartupEntry.Active;
      end;
    VK_F11:
      begin
        SendMessage(handle, WM_STARTEDITING,
          Integer(VST.FocusedNode), COL_WAITFOR);
      end;
  end;
  VST.InvalidateNode(VST.FocusedNode);
end;

procedure TMainForm.VSTPaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  e: PStartupEntry;
begin
  e := Sender.GetNodeData(Node);
  if e^.Changed then
  begin
    TargetCanvas.Font.Style := [fsBold];
  end;
  if e^.Deleted then
    TargetCanvas.Font.Color := clWhite
  else if not (e^.Editable or AllEditable) then
    TargetCanvas.Font.Color := clSilver
  else if (Column = COL_PATH) and (e.Path[2] = ':') and not TPath.Exists(TPath.Expand(e^.Path)) then
    TargetCanvas.Font.Color := clWhite
  else
  begin
    if Sender.Selected[Node] then
      TargetCanvas.Font.Color := clHighlightText
    else
      TargetCanvas.Font.Color := Sender.Font.Color;
  end;
end;

procedure TMainForm.VSTPMExecuteEntryMIClick(Sender: TObject);
begin
  ShellExecuteW(0, 'open',
    PWideChar(SelectedStartupEntry.Path),
    PWideChar(SelectedStartupEntry.Arguments),
    PWideChar(TPath.ExtractPath(SelectedStartupEntry.Path)),
    SW_SHOWNORMAL);
end;

procedure TMainForm.VSTPopupMenuPopup(Sender: TObject);
begin
  if SelectedStartupEntry.Editable or AllEditable then
  begin
    ResetEntryMI.Enabled := SelectedStartupEntry.Changed;
    EditEntryMI.Enabled := true;
    DeleteEntryMI.Enabled := not SelectedStartupEntry.Deleted;
  end
  else
  begin
    EditEntryMI.Enabled := false;
    ResetEntryMI.Enabled := false;
    DeleteEntryMI.Enabled := false;
  end;
  case SelectedStartupEntry.RunType of
    rtLnk: GoToMI.Caption := '&Go to entry''s file...';
    else GoToMI.Caption := '&Go to entry''s registry key...';
  end;
end;

procedure TMainForm.WMStartEditing(var Message: TMessage);
begin
  VST.EditNode(Pointer(Message.WParam), Message.LParam);
end;

function TMainForm.AddNode(Autostart: TStartupEntry; Parent: PVirtualNode): PVirtualNode;
var
  data: PStartupEntry;
begin                                        
  Result := VST.AddChild(Parent);
  data := PStartupEntry(VST.GetNodeData(Result));
  data^ := Autostart;
end;

function TMainForm.AddNode(Parent: PVirtualNode): PVirtualNode;
var
  data: PStartupEntry;
begin                                        
  Result := VST.AddChild(Parent);
  data := PStartupEntry(VST.GetNodeData(Result));
  data^ := TStartupEntry.Create(Result);
  data^.OnChanged := StartupEntryChanged;
end;

procedure TMainForm.StartMinimizedMIClick(Sender: TObject);
begin
  TStartupAceSettings.StartMinimized := StartMinimizedMI.Checked;
end;

procedure TMainForm.StartPausedMIClick(Sender: TObject);
begin
  TStartupAceSettings.StartPaused := StartPausedMI.Checked;
end;

procedure TMainForm.StartupEntryChanged(Sender: TStartupEntry);
begin
  VST.InvalidateNode(Sender.TreeNode);
end;

procedure TMainForm.StartupEntryPanelCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := false;
end;

procedure TMainForm.AboutMIClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do
  begin
    try
      ShowModal;
    finally
      Free;
    end;
  end;
end;

{ TEntryEditLink }

procedure TEntryEditLink.ArgOptionsInsertPathClick(Sender: TObject);
begin
  PathControls.InsertPath(FEdit as TSpTbxEdit);
end;

procedure TEntryEditLink.ArgOptionsLongListClick(Sender: TObject);
var
  editForm: TEditLongStringsForm;
begin
  editForm := TEditLongStringsForm.Create(FTree);
  try
    editForm.Caption := 'Edit arguments of startup entry "' +
      PStartupEntry(FTree.GetNodeData(FTree.FocusedNode)).Caption + '"';
    editForm.Text := (FEdit as TSpTbxEdit).Text;
    if editForm.Execute then
    begin
      (FEdit as TSpTbxEdit).Text := editForm.Text;
    end;
  finally
    editForm.Free;
  end;
end;

function TEntryEditLink.BeginEdit: Boolean;
var
  I: Integer;
begin
  FEdit.Show;
  FEdit.SetFocus;
  for I := 0 to Length(FExtraControls) - 1 do
    FExtraControls[I].Show;
  Result := True;
end;

procedure TEntryEditLink.BrowseForPath(Sender: TObject);
begin
  FForm.TntOpenDialog1.FileName := (FEdit as TSpTbxEdit).Text; 
  if FForm.TntOpenDialog1.Execute then
  begin
    (FEdit as TSpTbxEdit).Text := FForm.TntOpenDialog1.FileName;
  end; 
end;

function TEntryEditLink.CancelEdit: Boolean;
begin
  FEdit.Hide;
  Result := True;
end;

destructor TEntryEditLink.Destroy;
var
  I: Integer;
begin
  FEdit.Free;
  for I := 0 to Length(FExtraControls) - 1 do
  begin
    FExtraControls[I].Free;
  end;
  SetLength(FExtraControls, 0);
  for I := 0 to Length(FExtraComponents) - 1 do
  begin
    FExtraComponents[I].Free;
  end;
  SetLength(FExtraComponents, 0);
  inherited;
  FTree.SetFocus;
end;

procedure TEntryEditLink.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  CanAdvance: Boolean;
begin
  case Key of
    VK_ESCAPE:
    begin
      FTree.CancelEditNode;
      Key := 0;
    end;
    VK_RETURN:
    begin
      FTree.EndEditNode;
      Key := 0;
    end;
    VK_UP, VK_DOWN:
    begin
      CanAdvance := Shift = [];
      if FEdit is TCustomComboBox then
//        CanAdvance := CanAdvance and not (TCustomComboBox(FEdit).DroppedDown);
        CanAdvance := False;

      if CanAdvance then
      begin
        PostMessage(FTree.Handle, WM_KEYDOWN, Key, 0);
        Key := 0;
      end;
    end;
  end;
end;

function TEntryEditLink.EndEdit: Boolean;
var
  e: PStartupEntry;
  s: array [0..MAX_PATH] of WChar;
begin
  e := FTree.GetNodeData(FNode);
  case FColumn of
    TMainForm.COL_CAPTION:
    begin
      GetWindowTextW(FEdit.Handle, s, MAX_PATH);
      e.Caption := WideString(s);
    end;
    TMainForm.COL_PATH:
    begin
      GetWindowTextW(FEdit.Handle, s, MAX_PATH);
      e.Path := WideString(s);
    end;
    TMainForm.COL_ARGS:
    begin   
      GetWindowTextW(FEdit.Handle, s, MAX_PATH);
      e.Arguments := WideString(s);
    end;
    TMainForm.COL_TYPE:
    begin        
      e.RunType := TRunType(TSpTbxComboBox(FEdit).ItemIndex);
    end;
    TMainForm.COL_DELAY:
    begin
      if GetWindowTextW(FEdit.Handle, s, 6) > 0 then
      begin
        try
          e.Delay := StrToInt(WideString(s));
        except                                          
          Result := False;
          MessageBoxW(FEdit.Handle, 'This is not a number! You have to enter an integral number between 0 and 86400!',
            'Errorneous Input', MB_OK or MB_ICONWARNING);
          FEdit.SetFocus;
          Exit;
        end;
      end;
    end;
    TMainForm.COL_ALLUSERS:
    begin
      e.AllUsers := Boolean(TSpTbxComboBox(FEdit).ItemIndex);
    end;
    TMainForm.COL_ACTIVE:
    begin
      e.Active := Boolean(TSpTbxComboBox(FEdit).ItemIndex);
    end;
    TMainForm.COL_WAITFOR:
    begin
      GetWindowTextW(FEdit.Handle, s, MAX_PATH);
      e.WaitFor := WideString(s);
    end;
  end;
  FTree.InvalidateNode(FNode);
  Result := True;   
  FTree.SetFocus;
end;

function TEntryEditLink.GetBounds: TRect;
begin
  Result := FEdit.BoundsRect;
end;

procedure TEntryEditLink.HideControls;
var
  I: Integer;
begin
  FEdit.Hide;
  for I := 0 to Length(FExtraControls) - 1 do
  begin
    FExtraControls[I].Hide;
  end;
  FTree.SetFocus;
end;

function TEntryEditLink.PrepareEdit(Tree: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex): Boolean;
var
  e: PStartupEntry;
  aMenuItem: TMenuItem;
begin
  Result := true;
  FTree := Tree as TVirtualStringTree;
  FForm := FTree.Parent.Parent as TMainForm;
  FNode := Node;
  FColumn := Column;

  FreeAndNil(FEdit);
  e := Tree.GetNodeData(Node);
  case Column of
    TMainForm.COL_CAPTION:
    begin
      FEdit := TSpTbxEdit.Create(nil);
      with FEdit as TSpTbxEdit do
      begin
        Visible := False;
        Parent := Tree;
        Text := e.Caption;   
        OnKeyDown := EditKeyDown;
      end;
    end;
    TMainForm.COL_PATH:
    begin
      FEdit := TSpTbxEdit.Create(nil);
      with FEdit as TSpTbxEdit do
      begin                       
        Visible := False;
        Parent := Tree;
        Text := e.Path;   
        OnKeyDown := EditKeyDown;
      end;    
      SetLength(FExtraControls, 1);
      FExtraControls[0] := TButton.Create(Tree);
      with FExtraControls[0] as TButton do
      begin
        Visible := False;
        Parent := Tree;
        OnClick := BrowseForPath;
        Caption := '...';
      end;
    end;
    TMainForm.COL_ARGS:
    begin
      FEdit := TSpTbxEdit.Create(nil);
      with FEdit as TSpTbxEdit do
      begin            
        Visible := False;
        Parent := Tree;
        Text := e.Arguments;
        OnKeyDown := EditKeyDown;
      end;
      SetLength(FExtraControls, 1);
      FExtraControls[0] := TButton.Create(Tree);
      with FExtraControls[0] as TButton do
      begin
        Visible := False;
        Parent := Tree;
        OnClick := ShowArgumentOptions;
        Caption := 'v';
      end;
      SetLength(FExtraComponents, 1);
      FExtraComponents[0] := TTntPopupMenu.Create(Tree);
      with FExtraComponents[0] as TPopupMenu do
      begin
        aMenuItem := TMenuItem.Create(FExtraComponents[0]);
        aMenuItem.Caption := 'Insert path';
        aMenuItem.OnClick := ArgOptionsInsertPathClick;
        Items.Add(aMenuItem);
        aMenuItem := TMenuItem.Create(FExtraComponents[0]);
        aMenuItem.Caption := 'Long argument list...';
        aMenuItem.OnClick := ArgOptionsLongListClick;
        Items.Add(aMenuItem);
      end;
    end;
    TMainForm.COL_TYPE:
    begin
      FEdit := TSpTbxComboBox.Create(nil);
      with FEdit as TSpTbxComboBox do
      begin           
        Visible := False;
        Parent := Tree;
        Items.Add('Startup Ace');
        Items.Add('Registry');
        Items.Add('Startup Folder');
        ItemIndex := Integer(e.RunType);
        OnKeyDown := EditKeyDown;
      end;
    end;
    TMainForm.COL_DELAY:
    begin
      FEdit := TSpTbxSpinEdit.Create(nil);
      with FEdit as TSpTbxSpinEdit do
      begin           
        Visible := False;
        Parent := Tree;
        MaxValue := 86400;
        MinValue := 0;
        Value := e.Delay;
        OnKeyDown := EditKeyDown; 
      end;
    end;
    TMainForm.COL_ALLUSERS:
    begin
      FEdit := TSpTbxComboBox.Create(nil);
      with FEdit as TSpTbxComboBox do
      begin             
        Visible := False;
        Parent := Tree;
        Items.Add('No');
        Items.Add('Yes');
        ItemIndex := Integer(e.AllUsers);
        OnKeyDown := EditKeyDown;
      end;
    end;
    TMainForm.COL_ACTIVE:
    begin
      FEdit := TSpTbxComboBox.Create(nil);
      with FEdit as TSpTbxComboBox do
      begin  
        Visible := False;
        Parent := Tree;
        Items.Add('No');
        Items.Add('Yes');
        ItemIndex := Integer(e.Active);
        OnKeyDown := EditKeyDown;
      end;
    end;
    TMainForm.COL_WAITFOR:
    begin
      FEdit := TSpTbxEdit.Create(nil);
      with FEdit as TSpTbxEdit do
      begin                       
        Visible := False;
        Parent := Tree;
        Text := e.WaitFor;   
        OnKeyDown := EditKeyDown;
      end;
    end
    else
    begin
      Result := false;
    end;
  end;
end;

procedure TEntryEditLink.ProcessMessage(var Message: TMessage);
begin
  FEdit.WindowProc(Message);
end;

procedure TEntryEditLink.SetBounds(R: TRect);
var
  Dummy: Integer;
  EditRect: TRect;
  ButtonRect: TRect;
begin
  FTree.Header.Columns.GetColumnBounds(FColumn, Dummy, R.Right);
  if Length(FExtraControls) = 0 then
    FEdit.BoundsRect := R
  else
  begin
    EditRect := R;
    EditRect.Right := R.Right - 20;
    ButtonRect := R;
    ButtonRect.Left := R.Right - 20;
    FEdit.BoundsRect := EditRect;
    FExtraControls[0].BoundsRect := ButtonRect;
  end;
end;

procedure TEntryEditLink.ShowArgumentOptions(Sender: TObject);
var
  p: TPoint;
begin
  p.X := FExtraControls[0].BoundsRect.Left;
  p.Y := FExtraControls[0].BoundsRect.Bottom;
  p := FTree.ClientToScreen(p);
  (FExtraComponents[0] as TPopupMenu).Popup(
    p.X,
    p.Y);
end;

end.
