(*
StartupAce RenameEntryFrm.pas Unit (startup entry renaming form's implementation)
Copyright (C) 2006  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)
unit RenameEntryFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TntStdCtrls;

type
  TRenameEntryForm = class(TForm)
    NewNameEdit: TTntEdit;
    OKButton: TTntButton;
    CancelButton: TTntButton;
    NewNameEditLabel: TTntLabel;
    procedure FormShow(Sender: TObject);
    procedure NewNameEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  protected
    procedure SetNewEntryName(const Value: WideString);
    function GetNewEntryName: WideString;
  published
    function Execute: Boolean;
    property NewEntryCaption: WideString read GetNewEntryName write SetNewEntryName;
    { Public-Deklarationen }
  end;

var
  RenameEntryForm: TRenameEntryForm;

implementation

{$R *.dfm}

{ TRenameEntryForm }

function TRenameEntryForm.Execute: Boolean;
begin
  Result := Self.ShowModal = mrOK;
end;

procedure TRenameEntryForm.FormShow(Sender: TObject);
begin
  NewNameEdit.SetFocus;
end;

function TRenameEntryForm.GetNewEntryName: WideString;
begin
  Result := Self.NewNameEdit.Text;
end;

procedure TRenameEntryForm.NewNameEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    OKButton.Click;
end;

procedure TRenameEntryForm.SetNewEntryName(const Value: WideString);
begin
  Self.NewNameEdit.Text := Value;
end;

end.
