(*
StartupAce StartupEntryFilter.pas Unit (class TStartupEntryFilter)
Copyright (C) 2006  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)

unit StartupEntryFilter;

interface

uses
  StartupEntry;

type
  TSimpleNotifyEvent = procedure of object;

  TStartupEntryFilter = class
    strict private
      FFilter: Cardinal;
      FComparasionEntry: TStartupEntry;
      FOnChanged: TSimpleNotifyEvent;
    protected
      procedure SetFilter(Value: Cardinal);
    public
      constructor Create; overload; virtual;
      destructor Destroy; reintroduce; virtual;
      property Filter: Cardinal read FFilter write SetFilter;
      property ComparasionEntry: TStartupEntry read FComparasionEntry;
      property OnChanged: TSimpleNotifyEvent read FOnChanged write FOnChanged;
  end;

implementation

{ TStartupEntryFilter }

constructor TStartupEntryFilter.Create;
begin
  self.FComparasionEntry := TStartupEntry.Create(nil);
end;

destructor TStartupEntryFilter.Destroy;
begin
  FComparasionEntry.Free;
end;

procedure TStartupEntryFilter.SetFilter(Value: Cardinal);
begin
  if FFilter <> Value then
  begin
    FFilter := Value;
    if Assigned(FOnChanged) then
      FOnChanged;
  end;
end;

end.
