(*
StartupAce UnsavedChangesDlg.pas Unit (unsaved changes dialog's implementation)
Copyright (C) 2006  Jakob Reschke

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this software; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)

unit UnsavedChangesDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, TBXDkPanels, ExtCtrls;

type
  TUnsavedChangesDialog = class(TForm)
    SpTBXPanel3: TSpTBXPanel;
    SpTBXPanel1: TSpTBXPanel;
    SaveBtn: TSpTBXButton;
    DiscardBtn: TSpTBXButton;
    CancelBtn: TSpTBXButton;
    SpTBXLabel1: TSpTBXLabel;
    procedure SaveBtnClick(Sender: TObject);
    procedure DiscardBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  strict private
    FDialogResult: Integer;
  public
    { Public-Deklarationen }
    const ResultCancel = 0;             
    const ResultSave = 1;
    const ResultDiscard = 2;

    class function Show: Integer; static;
    
    property DialogResult: Integer read FDialogResult;
  end;

var
  UnsavedChangesDialog: TUnsavedChangesDialog;

implementation

{$R *.dfm}

{ TUnsavedChangesDialog }

class function TUnsavedChangesDialog.Show: Integer;
begin
  with TUnsavedChangesDialog.Create(nil) do
  begin
    try
      ShowModal;
      Result := DialogResult; 
    finally
      Free;
    end;
  end;
end;

procedure TUnsavedChangesDialog.CancelBtnClick(Sender: TObject);
begin
  FDialogResult := ResultCancel;
  Close;
end;

procedure TUnsavedChangesDialog.DiscardBtnClick(Sender: TObject);
begin
  FDialogResult := ResultDiscard;
  Close;
end;

procedure TUnsavedChangesDialog.SaveBtnClick(Sender: TObject);
begin
  FDialogResult := ResultSave;
  Close;
end;

end.
